# coding=utf-8
__author__ = 'Antoine JAMIN'

import mosquitto
import pymongo
import demjson
import time
import json

#variables globales

BrokerIP='localhost' #Mettre a localhost pour les tests internes et à 192.168.0.25 pour le serveur médecin
BrokerPORT=1883 #Mettre à 1883 pour les tests internes et à 8883 pour le serveur médecin
ConnectLOGIN='patient1'
ConnectMDP='p1agi'
MongodbIP='localhost' #Mettre a localhost pour les tests internes et à 192.168.0.25 pour le serveur médecin
MongodbPORT=27017

#Definition des clients
clientMosquitto=mosquitto.Mosquitto()
clientMongodb=pymongo.MongoClient(MongodbIP, MongodbPORT)

#Connections
#Mettre la ligne ci-dessous en commentaire pour fonctionnement en local
#clientMosquitto.username_pw_set(ConnectLOGIN,password=ConnectMDP)
clientMosquitto.connect(BrokerIP,BrokerPORT,60)
db=clientMongodb.AGIpc
patient=db.patients
print("Database names")
print(clientMongodb.database_names())
print("Collection names")
print(db.collection_names())

#Souscription a la boite recevant toutes les donnees des patients
clientMosquitto.subscribe('dataPatient/#',0)

#Definition des events callbacks
def on_connect(mosq,obj,rc):
    if(rc==0):
        print('Connection au Broker OK')
    else :
        print('Connection au Broker NOK')


def on_subscribe(mosq,obj,mid,granted_qos):
    print("Subscribed : "+str(mid)+" "+str(granted_qos))

def on_message(mosq,obj,msg):
    #print(msg.topic+" "+str(msg.qos)+" "+msg.payload)
    str_post = msg.payload
    print(str_post.decode("utf-8"))
    post=demjson.decode(str_post)
    cursor=db.patients.find({"id":post['id']})
    horodate = time.strftime('%d/%m/%y %H:%M', time.localtime())
    i=0;
    print(cursor)
    for patient in cursor:
        i=i+1
        print(i);
        print(patient)
    if(i==0):
        print('NULL')
        db.patients.insert({'id':post['id'],'nom':post['nom'],'prenom':post['prenom'], 'releve':[{'horodate':horodate,'temperature':post['temperature'],'fatigue':post['fatigue'],'sechbucc':post['sechbucc'],'doulbucc':post['doulbucc'],'aphtes':post['aphtes'],'vomi':post['vomi'],'age':post['age'],'taille':post['taille'],'poids':post['poids'],'mg':post['mg']}]})
    else:
        print('NON NULL')
        db.patients.update({'id':post['id']},{'$push' : {'releve':{'horodate':horodate,'temperature':post['temperature'],'fatigue':post['fatigue'],'sechbucc':post['sechbucc'],'doulbucc':post['doulbucc'],'aphtes':post['aphtes'],'vomi':post['vomi'],'age':post['age'],'taille':post['taille'],'poids':post['poids'],'mg':post['mg']}}})


#Assigner les events callbacks
clientMosquitto.on_connect=on_connect
clientMosquitto.on_message=on_message
clientMosquitto.on_subscribe=on_subscribe

while clientMosquitto.loop() == 0:
    pass